-----------------------------------------------------------------------------------------------
--
--
--
-----------------------------------------------------------------------------------------------

local addon = CreateFrame('Frame')

addon.__appName = "KiwiPlates" 
addon.__addonName = ... 
addon:RegisterEvent("ADDON_LOADED")
addon:RegisterEvent("PLAYER_LOGIN")
addon:SetScript("OnEvent", function(frame, event, name)
	if event == "ADDON_LOADED" and name == addon.__addonName then
		addon.__loaded = true
	end
	if addon.__loaded and IsLoggedIn() then
		addon:UnregisterAllEvents()
		addon:SetScript( "OnEvent", function(frame, event, ...) 
			local func = frame[event]
			if func then func( frame, ... ) end		
		end )
		addon:Run()
	end	
end)

----------------------------------------------------------------
-- Modules management
----------------------------------------------------------------

addon.modules = {}

function addon:NewModule(name)
	local module = {}
	self.modules[name] = module
	return module
end

----------------------------------------------------------------
-- 
----------------------------------------------------------------

function addon:Run()
	self:InitDatabase('KiwiPlatesDb')
	self:InitOptions()
	self:InitDataBroker()		
	self:Update()
	self.Run = nil
end

----------------------------------------------------------------
-- Options Setup
----------------------------------------------------------------

function addon:InitOptions()
	local optionsFrame = CreateFrame( "Frame", nil, UIParent )
	optionsFrame.name = self.__appName
	local button = CreateFrame("BUTTON", nil, optionsFrame, "UIPanelButtonTemplate")
	button:SetText("Configure KiwiPlates")
	button:SetSize(225,32)
	button:SetPoint('TOPLEFT', optionsFrame, 'TOPLEFT', 20, -20)
	button:SetScript("OnClick", function(self) 
		HideUIPanel(InterfaceOptionsFrame) 
		HideUIPanel(GameMenuFrame) 
		addon.OnChatCommand()
	end)
	InterfaceOptions_AddCategory(optionsFrame)
	self.optionsFrame = optionsFrame
end	

function addon.OnChatCommand()
	LibStub("AceConfig-3.0"):RegisterOptionsTable(addon.__appName, addon.OptionsTable)
	LibStub("AceConfigDialog-3.0"):SetDefaultSize(addon.__appName, 675, 585)
	addon.OnChatCommand = function()
		local LIB = LibStub("AceConfigDialog-3.0")
		LIB[ LIB.OpenFrames.KiwiPlates and 'Close' or 'Open' ](LIB, addon.__appName)
	end
	SlashCmdList[ addon.__addonName:upper() ] = addon.OnChatCommand	
	addon.OnChatCommand()
end	

SlashCmdList[ addon.__addonName:upper() ] = addon.OnChatCommand
_G[ 'SLASH_'..addon.__addonName:upper()..'1' ] = '/kiwiplates'

----------------------------------------------------------------
--
----------------------------------------------------------------

KiwiPlates = addon
